
//+------------------------------------------------------------------+
//|                                 KurkaTrader THE BIG PROVIDER.mq4 |
//|                                      Copyright  2006, KurkaFund |
//|                                         http://www.kurkafund.com |
//|   Do not use for live trading without written consent from author|
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, KurkaFund."
#property link      "http://www.kurkafund.com"
#include <stdlib.mqh>

//---- input parameters
      
extern int        SIGNALCANDLE         = 1;            
extern double     TakeProfit           = 38;    
extern double     StopLoss             = 100;         
extern int        OrderSlippage        = 3;             
extern int        MaxLongOrders        = 15;  
extern int        MaxShortOrders       = 10; 

//Main Bands
extern int        BANDSTIME            = PERIOD_M30;
extern int        BANDSPERIOD          = 20;
extern int        ADXTIME              = PERIOD_M15;
extern int        ADXPER               = 20;
extern int        CCITIME              = PERIOD_H1;
extern int        CCIPER               = 14;
extern int        CCILevel1            = 75;
extern int        CCILevel2            = 150;
extern int        CCILevel3            = 225;
extern int        CCTtrail             = 5;
extern int        OSMATIME             = PERIOD_M30;

extern double     BANDSDEVIATION1      = 1;
extern double     BANDSDEVIATION2      = 2;
extern double     BANDSDEVIATION3      = 3;

extern bool       Scalp                = true;
extern int        ScalpLoss            = 20;
extern int        ScalpProfit          = 10;
extern int        ScalpTrail           = 10;
extern int        HILOWPER             = 5;

extern bool       UseTrail             = true;
extern int        Trail                = 20;

extern bool       UseStoch             = true;
extern int        STOCHTIME            = PERIOD_M15;




//---- internal parameters

int        MagicLong            = 13131313;  
int        MagicShort           = 25252525; 
int        MagicScalp           = 38383838;     


//---------------------------------------------------------------------------------------------------------------------------------------------------------------
int init() { return(0); }
int deinit() { return(0); }
//---------------------------------------------------------------------------------------------------------------------------------------------------------------
int start() {
   if(Bars<100){
      Print("bars less than 100");
      return(0);
      }
   if(StopLoss<10){
      Print("StopLoss less than 10");
      return(0);
      }
   if(TakeProfit<10){
      Print("TakeProfit less than 10");
      return(0);
      }
  
 int LongCount=0,ShortCount=0,trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--){
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);{
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicLong){
    LongCount++;
    }
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicShort){
    ShortCount++;
    }
   }
  }
    if (LongCount<MaxLongOrders)   {LookForLong();}
    if (ShortCount<MaxShortOrders) {LookForShort();}
    if (LongCount>0)               {ManageLongOrders();}
    if (ShortCount>0)              {ManageShortOrders();}
    if (Scalp)                     {Scalp();ManageScalpOrders();}
    ChartComment();
return (0);
}

//=======================================================================================================================================
//                                        FUNCTIONS
//=======================================================================================================================================
void LookForLong(){

     double OSMA             = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE); 
     double pOSMA            = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE+1);
     double CCI              = iCCI(NULL,CCITIME,CCIPER,PRICE_TYPICAL,SIGNALCANDLE);  
     double pCCI             = iCCI(NULL,CCITIME,CCIPER,PRICE_TYPICAL,SIGNALCANDLE+1);
     double STOCHOSCMAIN     = iCustom(NULL,STOCHTIME,"Zerolagstochs",0,SIGNALCANDLE);
     double STOCHOSCSIGNAL   = iCustom(NULL,STOCHTIME,"Zerolagstochs",1,SIGNALCANDLE);
     double pSTOCHOSCMAIN    = iCustom(NULL,STOCHTIME,"Zerolagstochs",0,SIGNALCANDLE+1);
     double pSTOCHOSCSIGNAL  = iCustom(NULL,STOCHTIME,"Zerolagstochs",1,SIGNALCANDLE+1);
     double pHigh            = iHigh(NULL,0,SIGNALCANDLE+1);
     double pLow             = iLow(NULL,0,SIGNALCANDLE+1);
     if ((CCI > pCCI &&  OSMA > pOSMA && STOCHOSCMAIN > STOCHOSCSIGNAL && pSTOCHOSCMAIN <= pSTOCHOSCSIGNAL )){
          GoLong();
     }
    }
void LookForShort(){
     double STOCHOSCMAIN     = iCustom(NULL,STOCHTIME,"Zerolagstochs",0,SIGNALCANDLE);
     double STOCHOSCSIGNAL   = iCustom(NULL,STOCHTIME,"Zerolagstochs",1,SIGNALCANDLE);
     double pSTOCHOSCMAIN    = iCustom(NULL,STOCHTIME,"Zerolagstochs",0,SIGNALCANDLE+1);
     double pSTOCHOSCSIGNAL  = iCustom(NULL,STOCHTIME,"Zerolagstochs",1,SIGNALCANDLE+1);
     double pHigh            = iHigh(NULL,0,SIGNALCANDLE+1);
     double pLow             = iLow(NULL,0,SIGNALCANDLE+1);
     //if (STOCHOSCMAIN < STOCHOSCSIGNAL && pSTOCHOSCMAIN <= pSTOCHOSCSIGNAL && pHigh-pLow<25*Point && Bid < pLow && STOCHOSCMAIN >70){
     //GoShort();
     //}
    }

//=======================================================================================================================================
void ManageLongOrders(){

     double OSMA             = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE); 
     double pOSMA            = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE+1);
     double ppOSMA           = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE+2);
     double BOLLUPPER1   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION1,0,PRICE_MEDIAN,MODE_UPPER,SIGNALCANDLE); 
     double BOLLUPPER2   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION2,0,PRICE_MEDIAN,MODE_UPPER,SIGNALCANDLE);
     double BOLLUPPER3   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION3,0,PRICE_MEDIAN,MODE_UPPER,SIGNALCANDLE); 
     double BOLLLOWER1   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION1,0,PRICE_MEDIAN,MODE_LOWER,SIGNALCANDLE); 
     double BOLLLOWER2   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION2,0,PRICE_MEDIAN,MODE_LOWER,SIGNALCANDLE); 
     double BOLLLOWER3   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION3,0,PRICE_MEDIAN,MODE_LOWER,SIGNALCANDLE); 
     double SMA            = iMA(NULL,BANDSTIME,BANDSPERIOD,0,MODE_SMA,PRICE_MEDIAN,SIGNALCANDLE);
     double pSMA           = iMA(NULL,BANDSTIME,BANDSPERIOD,0,MODE_SMA,PRICE_MEDIAN,SIGNALCANDLE+1);
     double CURRENTSMA     = iMA(NULL,BANDSTIME,BANDSPERIOD,0,MODE_SMA,PRICE_MEDIAN,SIGNALCANDLE);
     
     //CCI trail
     double CCI              = iCCI(NULL,CCITIME,CCIPER,PRICE_TYPICAL,SIGNALCANDLE);  
     double pCCI             = iCCI(NULL,CCITIME,CCIPER,PRICE_TYPICAL,SIGNALCANDLE+1); 
     

   for (int cnt = OrdersTotal(); cnt >= 0; cnt--) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicLong) {
           if (Ask > BOLLUPPER3) {
              OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), OrderSlippage, Blue);
              }
           }
        }
        if (UseTrail){
        BuyTrail();
        }
   } 
void ManageShortOrders(){
     double BOLLUPPER1   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION1,0,PRICE_MEDIAN,MODE_UPPER,SIGNALCANDLE); 
     double BOLLUPPER2   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION2,0,PRICE_MEDIAN,MODE_UPPER,SIGNALCANDLE);
     double BOLLUPPER3   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION3,0,PRICE_MEDIAN,MODE_UPPER,SIGNALCANDLE); 
     double BOLLLOWER1   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION1,0,PRICE_MEDIAN,MODE_LOWER,SIGNALCANDLE); 
     double BOLLLOWER2   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION2,0,PRICE_MEDIAN,MODE_LOWER,SIGNALCANDLE); 
     double BOLLLOWER3   = iBands(NULL,BANDSTIME,BANDSPERIOD,BANDSDEVIATION3,0,PRICE_MEDIAN,MODE_LOWER,SIGNALCANDLE); 
     double SMA            = iMA(NULL,BANDSTIME,BANDSPERIOD,0,MODE_SMA,PRICE_MEDIAN,SIGNALCANDLE);
     double pSMA           = iMA(NULL,BANDSTIME,BANDSPERIOD,0,MODE_SMA,PRICE_MEDIAN,SIGNALCANDLE+1);
     double CURRENTSMA     = iMA(NULL,BANDSTIME,BANDSPERIOD,0,MODE_SMA,PRICE_MEDIAN,SIGNALCANDLE);
      
      for (int cnt = OrdersTotal(); cnt >= 0; cnt--) {
          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
             if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicShort) {
                if (Bid < BOLLLOWER2 ) {
                   SellTrail();
                   GoLong();
                   }
                if (Bid < BOLLLOWER3&&Bid>BOLLLOWER2+20*Point){
                   OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), OrderSlippage, Blue);
                   GoLong();  
                   }            
             }
          }
          if (UseTrail){
          SellTrail();
          }
    }  
//=======================================================================================================================================
//OrderEntry

void GoLong(){
      //double LongLots = NormalizeDouble((AccountFreeMargin()*Risk),2);
      OrderSend(Symbol(),OP_BUY,1, Ask, OrderSlippage,Bid-StopLoss*Point,Ask+TakeProfit*Point, "Open Buy", MagicLong, 0, Green);
      Print ("OPEN BUY :  ", OrderLots()," Ticket : # ",  OrderTicket());
      //OrderSend(Symbol(),OP_BUYSTOP,LongLots*Growth,Ask-(PipStep*Point),OrderSlippage,Bid-(StopLoss+PipStep)*Point,Ask+(TakeProfit+PipStep)*Point,"Buy Step 1",MagicLong,0,LightGreen); 
      //OrderSend(Symbol(),OP_BUYSTOP,LongLots*Growth,Ask-(PipStep+PipStep*Point),OrderSlippage,Bid-(StopLoss+PipStep+PipStep)*Point,Ask+(TakeProfit+PipStep+PipStep)*Point,"Buy Step 1",MagicLong,0,LightGreen); 
      //OrderSend(Symbol(),OP_BUYSTOP,LongLots*Growth,Ask-(PipStep+PipStep+PipStep*Point),OrderSlippage,Bid-(StopLoss+PipStep+PipStep+PipStep)*Point,Ask+(TakeProfit+PipStep+PipStep+PipStep)*Point,"Buy Step 1",MagicLong,0,LightGreen);
     Sleep(20000);
     return(0);
     }
void GoShort(){
      //double ShortLots = NormalizeDouble((AccountFreeMargin()*Risk),2);
      OrderSend(Symbol(),OP_SELL,1, Bid, OrderSlippage,Ask+StopLoss*Point,Bid-TakeProfit * Point, "Open Sell", MagicShort, 0, Red);
      Print ("OPEN SELL :  ", OrderLots()," Ticket : # ",  OrderTicket());
      Sleep(20000);
     return(0);
     }







//=======================================================================================================================================
//Scalper
void Scalp(){
   
   double RSI              = iRSI(NULL,0,14,PRICE_TYPICAL,SIGNALCANDLE); 
   double OSMA             = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE); 
   double pOSMA            = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE+1);
   double ADXPlusDI                 = iADX(NULL,ADXTIME,ADXPER,PRICE_TYPICAL,MODE_PLUSDI,SIGNALCANDLE); 
   double ADXMinusDI                = iADX(NULL,ADXTIME,ADXPER,PRICE_TYPICAL,MODE_MINUSDI,SIGNALCANDLE);
   double Bulls                     = iBullsPower(NULL,PERIOD_M30,20,PRICE_TYPICAL,SIGNALCANDLE); 
   double Bears                     = iBearsPower(NULL,PERIOD_M30,20,PRICE_TYPICAL,SIGNALCANDLE);
   double FifteenMinHighest         = iHighest(NULL,PERIOD_M15,MODE_HIGH,HILOWPER,SIGNALCANDLE); 
   double FifteenMinLowest          = iLowest(NULL,PERIOD_M15,MODE_LOW,HILOWPER,SIGNALCANDLE);
   double FiveMinHighest            = iHighest(NULL,PERIOD_M5,MODE_HIGH,HILOWPER,SIGNALCANDLE); 
   double FiveMinLowest             = iLowest(NULL,PERIOD_M5,MODE_LOW,HILOWPER,SIGNALCANDLE);
   double pHigh                     = iHigh(NULL,0,SIGNALCANDLE+1);
   double pLow                      = iLow(NULL,0,SIGNALCANDLE+1);
   //calculate limit orders 
   double buylimit,selllimit, buystop,sellstop;
   buylimit = pLow ;
   selllimit = pHigh ;
   
   if ( Ask <=  buylimit  && ADXPlusDI > ADXMinusDI  && OSMA > pOSMA && RSI < 30){// 
      OrderSend(Symbol(),OP_BUY,1, Ask, OrderSlippage,Bid-ScalpLoss*Point,Ask+ScalpProfit*Point, "Scalp Open Buy", MagicScalp, 0, Green);
      }

   if (Bid >= selllimit  && ADXPlusDI < ADXMinusDI &&  OSMA > pOSMA && RSI > 70){// 
      OrderSend(Symbol(), OP_SELL,1, Bid, OrderSlippage,Ask+ScalpLoss*Point,Bid-ScalpProfit * Point, "Scalp Open Sell", MagicScalp, 0, Red);
      }  
}

//=======================================================================================================================================
//ManageScalpOrders
void ManageScalpOrders(){
   double RSI              = iRSI(NULL,0,14,PRICE_TYPICAL,SIGNALCANDLE); 
   double OSMA             = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE); 
   double pOSMA            = iOsMA(NULL,OSMATIME,12,26,9,PRICE_CLOSE,SIGNALCANDLE+1);
   double ADXPlusDI                 = iADX(NULL,ADXTIME,ADXPER,PRICE_TYPICAL,MODE_PLUSDI,SIGNALCANDLE); 
   double ADXMinusDI                = iADX(NULL,ADXTIME,ADXPER,PRICE_TYPICAL,MODE_MINUSDI,SIGNALCANDLE);
   double Bulls                     = iBullsPower(NULL,PERIOD_M30,20,PRICE_TYPICAL,SIGNALCANDLE); 
   double Bears                     = iBearsPower(NULL,PERIOD_M30,20,PRICE_TYPICAL,SIGNALCANDLE);
   double FifteenMinHighest         = iHighest(NULL,PERIOD_M15,MODE_HIGH,HILOWPER,SIGNALCANDLE); 
   double FifteenMinLowest          = iLowest(NULL,PERIOD_M15,MODE_LOW,HILOWPER,SIGNALCANDLE);
   double FiveMinHighest            = iHighest(NULL,PERIOD_M5,MODE_HIGH,HILOWPER,SIGNALCANDLE); 
   double FiveMinLowest             = iLowest(NULL,PERIOD_M5,MODE_LOW,HILOWPER,SIGNALCANDLE);
   double pHigh                     = iHigh(NULL,0,SIGNALCANDLE+1);
   double pLow                      = iLow(NULL,0,SIGNALCANDLE+1);
   //calculate limit orders 
   double buylimit,selllimit, buystop,sellstop;
   buylimit = pLow ;
   selllimit = pHigh ;

for (int cnt = OrdersTotal(); cnt >= 0; cnt--) {
          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
             if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicScalp) {    
                if (OrderType()==OP_BUY) { 
                      if (RSI > 75){
                          OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), OrderSlippage, Blue);
                          }
                      if ((OrderStopLoss()<Bid-ScalpTrail*Point) || (OrderStopLoss()==0)){
                         OrderModify(OrderTicket(),OrderOpenPrice(),Bid-ScalpTrail*Point,OrderTakeProfit(),0,Yellow);  
                         } 
                      } 
               if (OrderType()==OP_SELL) {  
                     if (RSI < 25){
                        OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), OrderSlippage, Blue);
                        }
                     if ((OrderStopLoss()>Ask+ScalpTrail*Point) || (OrderStopLoss()==0)){ 
                         OrderModify(OrderTicket(),OrderOpenPrice(),Ask+ScalpTrail*Point,OrderTakeProfit(),0,Yellow); 
                         } 
                     } 
                  }  
             } 
         }      

//=======================================================================================================================================  
//Trailing Stops

void BuyTrail() { 
   for (int cnt = OrdersTotal(); cnt >= 0; cnt--) { 
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicLong) { 
            if (OrderType()==OP_BUY) { 
               if (Bid-OrderOpenPrice()>Trail*Point) { 
                  if ((OrderStopLoss()<Bid-Trail*Point) || (OrderStopLoss()==0))
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Trail*Point,OrderTakeProfit(),0,Yellow);  
               } 
            } 
         } 
      } 
   } 
} 
void SellTrail() { 
   for (int cnt = OrdersTotal(); cnt >= 0; cnt--) { 
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicShort) { 
            if (OrderType()==OP_SELL) { 
               if (OrderOpenPrice()-Ask>Trail*Point) { 
                  if ((OrderStopLoss()>Ask+Trail*Point) || (OrderStopLoss()==0)) 
                    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Trail*Point,OrderTakeProfit(),0,Yellow); 
               } 
            } 
         } 
      } 
   } 
} 

//=======================================================================================================================================  
//ChartComment
void ChartComment() {

   string sComment   = "";
   string sLine      = "--------------------------------------------------------------";
   string sNewLine   = "\n";
   
   sComment = sComment + sLine + sNewLine;
   sComment = sComment + "- KURKA TRADER, THE BIG PROVIDER - "+ sNewLine;
   sComment = sComment + sLine + sNewLine;
   sComment = sComment + "Account Name           : " + " KURKA FUND " + sNewLine;
   sComment = sComment + "Current Balance         : $ " + DoubleToStr(AccountBalance(),2) + sNewLine;
   sComment = sComment + "Account Equity          : $ " + DoubleToStr(AccountEquity(),2) + sNewLine;
   sComment = sComment + "Account FreeMargin   : $ " + DoubleToStr(AccountFreeMargin(),2) + sNewLine;
   sComment = sComment + "Account Profit           : $ " + DoubleToStr(AccountProfit(),2) + sNewLine;
   sComment = sComment + sLine + sNewLine;
   sComment = sComment + "OPEN POSITIONS... " + sNewLine;
   sComment = sComment + sLine + sNewLine;
   sComment = sComment + ":  Type  "+ ": Ticket   " + " :  Lots   "+" :   Swap   "+" :    Profit   "+sNewLine;
   int total = OrdersTotal();
   for(int cnt=0;cnt<total;cnt++){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==MagicLong){
            sComment = sComment + ":   Buy   :"+" # "+ DoubleToStr(OrderTicket( ),0)+"     :   "+DoubleToStr(OrderLots( ),2)+"   :  $ "+DoubleToStr(OrderSwap(),2)+"   :  $ "+DoubleToStr(OrderProfit(),2)+sNewLine;    
            }
      }
 
    for(cnt=0;cnt<total;cnt++){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==MagicShort){
            sComment = sComment + ":   Sell    :"+" # "+ DoubleToStr(OrderTicket( ),0)+"     :   "+DoubleToStr(OrderLots( ),2)+"   :  $ "+DoubleToStr(OrderSwap(),2)+"   :  $ "+DoubleToStr(OrderProfit(),2)+sNewLine;    
            }    
      }
    sComment = sComment + sNewLine;
    sComment = sComment + "SCALP ORDERS...           "+ sNewLine;
    sComment = sComment + sLine + sNewLine;
    sComment = sComment + ":  Type  "+ ": Ticket   " + " :  Lots   "+" :   Swap   "+" :    Profit   "+sNewLine;
    for(cnt=0;cnt<total;cnt++){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==MagicScalp){  
        if (OrderType() == OP_BUY){
            sComment = sComment + ":   Buy    :"+" # "+ DoubleToStr(OrderTicket( ),0)+"     :   "+DoubleToStr(OrderLots( ),2)+"   :  $ "+DoubleToStr(OrderSwap(),2)+"   :  $ "+DoubleToStr(OrderProfit(),2)+sNewLine;    
            }
        if (OrderType() == OP_SELL){
            sComment = sComment + ":   Sell   :"+" # "+ DoubleToStr(OrderTicket( ),0)+"     :   "+DoubleToStr(OrderLots( ),2)+"   :  $ "+DoubleToStr(OrderSwap(),2)+"   :  $ "+DoubleToStr(OrderProfit(),2)+sNewLine;    
            }    
            }
         }
   sComment = sComment + sLine + sNewLine;
   sComment = sComment + "TOTAL ORDERS : " + DoubleToStr(OrdersTotal(), 2) + sNewLine;
   sComment = sComment + sLine + sNewLine;   
   sComment = sComment + "BID : " + DoubleToStr(Bid, 4) + sNewLine;
   sComment = sComment + "ASK : " + DoubleToStr(Ask, 4) + sNewLine;
   sComment = sComment + sLine + sNewLine;
   Comment(sComment);

}



